<?
        // subfunktion fuer eea_pw
        // generierung von zufallszeichenkette
        function getRndChars($anzahl)  {
                srand ((double)microtime() * 1000000);

                $aZufall = array('=', '0', '1', '2', '3', '=', '4', '5', '6', '=', '7', '8', '9',
                                                 '=', 'a', 'b', 'c', 'd', 'e', 'f', '=', 'g', 'h', 'i', 'j', 'k',
                                                 'l', 'm', 'n', '=', 'o', 'p', 'q', 'r', 's', 't', '=', 'u', 'v',
                                                 'w', 'x', 'y', 'z', '=', 'A', 'B', '=', 'C', 'D', 'E', 'F', 'G',
                                                 'H', 'I', 'J', 'K', 'L', '=', 'M', 'N', 'O', '=', 'P', 'Q', 'R',
                                                 'S', 'T', 'U', '=', 'V', 'W', 'X', 'Y', 'Z', '=');

                if ($anzahl <= 0) { $anzahl = 1; }

                $sRndChars   = "";
                for ($i = 0; $i < $anzahl; $i++) {
                        $sRndChars .= $aZufall[(rand(0, 10000) % 74)];
                }
                return $sRndChars;
        } // end getRndChars


        // passwort-funktion zum ver- u. entschluesseln
        //
        // parameter
        // ---------
        // aktion:  encrypt o. decrypt
        // string:  klartext-pw bei encrypt
        //                        crypted-pw  bei decrypt
        //
        // return (assoz. array)
        // ------
        // ['success']                0 - fehler, 1 - fehlerfrei
        // ['value']                passwort (klartext o. verschluesselt) bzw. fehlermeldung
        //
        function eea_pw($aktion, $string) {
                switch (strtolower($aktion)) {
                        case 'encrypt':
                                if (strlen($string) != 8) {
                                        return array('success' => 0,
                                                                 'value'   => 'ERROR - password must consist of 8 characters');
                                } elseif (preg_match('/[^0-9a-zA-Z]/', $string)) {
                                        return array('success' => 0,
                                                                 'value'   => 'ERROR - allowed characters for setting the password: '.
                                                                 '0-9, a-z, A-Z');
                                }

                                $crypted =  getRndChars(1).substr($string, 4, 4).
                                                        getRndChars(1).substr($string, 0, 4).
                                                        getRndChars(1);
                                $crypted =  base64_encode($crypted);

                                $crypted =  getRndChars(2).substr($crypted, 8, 8).
                                                        getRndChars(2).substr($crypted, 0, 8).
                                                        getRndChars(2);
                                $crypted =  base64_encode($crypted);

                                $crypted =  getRndChars(3).base64_encode(strrev($crypted)).
                                                        getRndChars(2);

                                return array('success' => 1, 'value' => $crypted);
                                break;

                        case 'decrypt':
                                $decrypted = base64_decode(substr($string, 3, strlen($string) - 5));
                                $sTemp     = base64_decode(strrev($decrypted));

                                $decrypted = substr($sTemp, 2, strlen($sTemp) - 4);
                                $sTemp     = base64_decode( substr($decrypted, 10, 8).
                                                                                        substr($decrypted,  0, 8));

                                $decrypted = substr($sTemp, 6, 4).substr($sTemp, 1, 4);

                                return array('success' => 1, 'value' => $decrypted);
                                break;

                        default:
                                return array('success' => 0, 'value' => 'ERROR - invalid process');
                                break;
                }
        } // end eea_pw

        // beispiele
        /**
        $aErg = eea_pw('encrypt', 'meinpass');
        print_r($aErg);
        $aErg = eea_pw('decrypt', '=6fPT1RWTFrVFR6TUdhQ2hsWXlKVlB3b21Zd1oxVmlaRFQ=G=');
        print_r($aErg);

        **/
?>