<?	
	include "./update.data.php";
	include "./update.inc.php";

	$localVersion  = implode("", @file("./$versionFile"));
	$remoteVersion = implode("", @file($updateURL.$versionFile));

	if (trim($localVersion)  == "" ||
		trim($remoteVersion) == "" ) {
		echo "error: versionsdatei<br>\n";
		exit;
	} elseif ($localVersion == $remoteVersion) {
		echo "info: same version - no update needed<br>\n";
		exit;
	}

	echo "info: different version - update needed<br>\n";

	$zipArchiv = @gzopen($updateURL.$updateFile, 'rb');

	if (!$zipArchiv) {
		echo "error: getting zipArchiv<br>\n";
		exit;
	}

	$zipContent = "";

	while (!gzeof($zipArchiv)) {
		$zipContent .= gzread($zipArchiv, 1024);
	}

	$tmpTarFile = 'update.tar';
	$fh         = fopen($tmpTarFile, 'w');

	fputs($fh, $zipContent);
	fclose($fh);

	gzclose($zipArchiv);

	untar($tmpTarFile);

	unlink($tmpTarFile);

	echo "file-update fertig<br>\n";

	if (file_exists($befehlFile)) {
		include  "./$befehlFile";

		unlink($befehlFile);
	}

?>